clear all

use data_sedep_cfa.dta

drop F_DEPRES F_ESTEEM

sem sad blues depress lonely crying tired failure
display e(ll)


*sem (Depress -> sad blues depress lonely crying tired failure), var(Depress@1) nolog


**Strict Parallel
sjlog using "logs/factor_analysis_reliability/stbook/strict_parallel_dep", replace
sem (Depress -> sad@a1 blues@a1 depress@a1 lonely@a1 ///
				crying@a1 tired@a1 failure@a1) ///
	(sad blues depress lonely crying tired failure <- _cons@a), ///
	var(Depress@1) ///
	covstructure(e.sad e.blues e.depress ///
				 e.lonely e.crying e.tired e.failure, identity) nolog nocnsreport 
sjlog close, replace
				 
** Parallel
sjlog using "logs/factor_analysis_reliability/stbook/parallel_dep", replace
sem (Depress -> sad@a1 blues@a1 depress@a1 lonely@a1 ///
				crying@a1 tired@a1 failure@a1), ///
	var(Depress@1) ///
	covstructure(e.sad e.blues e.depress ///
				 e.lonely e.crying e.tired e.failure, identity) nolog nocnsreport
sjlog close, replace
				 
** Tau-Equivalent
sjlog using "logs/factor_analysis_reliability/stbook/tau_equiv_dep", replace
sem (Depress -> sad@a1 blues@a1 depress@a1 lonely@a1 ///
				crying@a1 tired@a1 failure@a1), ///
	var(Depress@1) nolog nocnsreport
sjlog close, replace
	
** Congeneric
sjlog using "logs/factor_analysis_reliability/stbook/congeneric", replace
sem (Depress -> sad blues depress lonely crying tired failure), ///
	var(Depress@1) nolog nocnsreport
sjlog close, replace


/*  ORIGINAL
sjlog using "logs/factor_analysis_reliability/stbook/one_fact_sem", replace
sem (Depress -> sad blues depress lonely crying tired failure), var(Depress@1) nolog coeflegend
nlcom (_b[sad:Depress] + _b[blues:Depress] + _b[depress:Depress] + ///
_b[lonely:Depress] + _b[crying:Depress] + _b[tired:Depress] + /// 
_b[failure:Depress])^2/((_b[sad:Depress] + _b[blues:Depress] + _b[depress:Depress] + ///
_b[lonely:Depress] + _b[crying:Depress] + _b[tired:Depress] + /// 
_b[failure:Depress])^2 + _b[var(e.sad):_cons] + _b[var(e.blues):_cons] + ///
_b[var(e.depress):_cons] + _b[var(e.lonely):_cons] + _b[var(e.crying):_cons] + ///
_b[var(e.tired):_cons] + _b[var(e.failure):_cons]), noheader
sjlog close, replace
*/


sjlog using "logs/factor_analysis_reliability/stbook/one_fact_sem", replace
sem (Depress -> sad blues depress lonely crying tired failure), var(Depress@1) nolog coeflegend
nlcom (_b[sad:Depress] + _b[blues:Depress] + _b[depress:Depress] + ///
_b[lonely:Depress] + _b[crying:Depress] + _b[tired:Depress] + /// 
_b[failure:Depress])^2/((_b[sad:Depress] + _b[blues:Depress] + _b[depress:Depress] + ///
_b[lonely:Depress] + _b[crying:Depress] + _b[tired:Depress] + /// 
_b[failure:Depress])^2 + _b[/var(e.sad)] + _b[/var(e.blues)] + ///
_b[/var(e.depress)] + _b[/var(e.lonely)] + _b[/var(e.crying)] + ///
_b[/var(e.tired)] + _b[/var(e.failure)]), noheader
sjlog close, replace



sem (Depress -> sad blues depress lonely crying tired failure), var(Depress@1) nolog coeflegend

capture program drop bootrel
program bootrel, rclass
	syntax [if] [in]
	quietly sem (Depress -> sad blues depress lonely crying tired failure), var(Depress@1) method(mlmv)
	quietly nlcom (_b[sad:Depress] + _b[blues:Depress] + _b[depress:Depress] + ///
_b[lonely:Depress] + _b[crying:Depress] + _b[tired:Depress] + /// 
_b[failure:Depress])^2/((_b[sad:Depress] + _b[blues:Depress] + _b[depress:Depress] + ///
_b[lonely:Depress] + _b[crying:Depress] + _b[tired:Depress] + /// 
_b[failure:Depress])^2 + _b[var(e.sad):_cons] + _b[var(e.blues):_cons] + ///
_b[var(e.depress):_cons] + _b[var(e.lonely):_cons] + _b[var(e.crying):_cons] + ///
_b[var(e.tired):_cons] + _b[var(e.failure):_cons]), noheader
	matrix temp = r(b)
	return scalar reliability=temp[1,1]
end

bootstrap r(reliability), reps(100): bootrel
estat boot, percentile bc	



estat gof, stats(all)
estat mindices
estat framework, fitted

display sqrt((e(chi2_ms) - e(df_ms)*e(N_groups))/(e(N)*e(df_ms)))



sem (Depress -> sad blues depress lonely crying tired failure) ///
    (SE -> worthy capable goodqual attitude)
sem, standardized
estat gof, stats(all)


sem (Depress -> sad blues depress lonely crying tired failure) ///
    (SE -> worthy capable goodqual attitude) ///
    (SE age cohesion -> Depress) 
estat gof, stats(all)



capture drop program bootmm
program bootmm, rclass
  syntax [if] [in]
  sureg (read math)(write math)(science read write math) `if' `in'
  return scalar indread  = [read]_b[math]*[science]_b[read]
  return scalar indwrite = [write]_b[math]*[science]_b[write]
  return scalar indtotal = [read]_b[math]*[science]_b[read]+ ///
                           [write]_b[math]*[science]_b[write] 
end

bootstrap r(indread) r(indwrite) r(indtotal), bca reps(5000) nodots: bootmm

